Package: stagePop
Type: Package
Title: Modelling the Population Dynamics of a Stage-Structured Species
        in Continuous Time
Version: 1.1-2
Date: 2022-05-05
Author: Helen Kettle
Maintainer: David Nutter <david.nutter@bioss.ac.uk>
Description: Provides facilities to implement and run population models of
    stage-structured species...
NeedsCompilation: no
URL: https://github.com/HelenKettle/StagePop
Suggests: R.rsp
VignetteBuilder: R.rsp
License: GPL-3 | file LICENSE
Imports: deSolve,PBSddesolve, grDevices, graphics
Collate: 'SolverOptions.R' 'addNamesToList.R' 'checkICs.R'
        'checkSolution.R' 'deathFunction.R' 'emigrationFunction.R'
        'developmentFunction.R' 'immigrationFunction.R'
        'durationFunction.R' 'reproductionFunction.R'
        'defaultRateFunctions.R' 'derivDede.R' 'derivPBS.R'
        'genericPlot.R' 'initConditions.R' 'namingVariables.R'
        'plotStrains.R' 'popModel.R' 'rateFuncCheck.R' 'rateFunction.R'
        'runStagePopExample.R' 'stagePop-package.R' 'sumStrains.R'
        'vecDivideFunc.R' 'vecToMatList.R'
Packaged: 2022-05-10 12:19:53 UTC; helen
Repository: CRAN
Date/Publication: 2022-05-10 13:50:02 UTC
RoxygenNote: 7.1.2
Built: R 4.6.0; ; 2026-04-25 22:34:44 UTC; unix

#Example where the juvenile stage duration is dependent upon temperature.

library(stagePop)

#solver.options=list(DDEsolver='deSolve',atol=1e-6,rtol=1e-6,hbsize=1e5)
solver.options=list(DDEsolver='PBS',tol=1e-8,hbsize=1e4,dt=0.01)
times=seq(0,365*2,1)

tempFunc=function(time,deltaT){
  T=15*(1-cos(2*pi*(time+80)/365))+deltaT
  return(T)}

gFunc=function(T){
  v=(1/60)*(1-((T-20)/20)^2)
  return(max(0,v))}

ccFunctions<-list(
                         reproFunc=function(x,time,species,strain){
                           A0=600;  q=11.5
                           reprod=q*x$Nematodes['adults',1]*exp(-x$Nematodes['adults',1]/A0)
                           return(max(0,reprod))
                         },
                         deathFunc=function(stage,x,time,species,strain){
                           a=c(0.05,0.05)
                           v=a[stage]
                           return(max(0,v))
                         },
                         develFunc=function(stage,x,time,species,strain){
                           T=tempFunc(time,deltaT)
                           v=gFunc(T)
                           return(v)
                         },
                         durationFunc=function(stage,x,time,species,strain){
                           if (time==0){
                             T=tempFunc(time,deltaT)
                             v=1/ccFunctions$develFunc(stage,x,time,species,strain)}
                           return(v)
                         },
                         immigrationFunc=function(stage,x,time,species,strain){
                           v=0
                           if (stage==2){if (time>=0 & time <=0.1){v=1}}
                           return(v)
                         },
                         emigrationFunc=function(stage,x,time,species,strain){return(0)}
)


Adults=matrix(0,nrow=length(times),ncol=2)
Juvs=matrix(0,nrow=length(times),ncol=2)
Taus=matrix(0,nrow=length(times),ncol=2)
ct=0
for (deltaT in c(0,3)){

  ct=ct+1

  modelOutput=popModel(
    numSpecies=1,
    numStages=2,
    timeDependLoss=FALSE,
    timeDependDuration=TRUE,
    ICs=list(matrix(0,nrow=2,ncol=1)),
    timeVec=times,
    solverOptions=solver.options,
    rateFunctions=ccFunctions,
    stageNames=list(c('juveniles','adults')),
    speciesNames=c('Nematodes'),
    saveFig=FALSE,
    figType='png'
    )

  Adults[,ct]=modelOutput[,'Nematodes.adults']
  Juvs[,ct]=modelOutput[,'Nematodes.juveniles']
  Taus[,ct]=modelOutput[,'dur.Nematodes.juveniles']
  
}

dev.new(bg='white')
par(mar=c(5,5,2,2))
T=seq(0,40,0.5); g=T*0
for (i in seq(1,length(T))){g[i]=gFunc(T[i])}
plot(T,g,type='l',xlab='Temperature (oC)',ylab='Juvenile development rate (/d)',cex.axis=1.5,cex.lab=1.5)


dev.new(bg='white')
par(mar=c(5,5,2,2))
time=modelOutput[,'time']
temps=tempFunc(time,0)
plot(c(0,max(times)),c(0,35),type="n",xlab='Time',ylab='Temperature',cex.axis=1.75,cex.lab=2)
lines(time,temps,col=1,lty=1,lwd=2)
temps=tempFunc(time,3)
lines(time,temps,col=2,lty=1,lwd=2)
legend('top',c('dT=0','dT=3'),lty=1,col=seq(1,2),lwd=2,cex=1.25,bty='n')



dev.new(bg='white')
par(mar=c(5,5,2,2))
plot(c(0,2*365),c(60,200),type="n",xlab='Time',ylab='Juvenile Stage Duration (d)',cex.axis=1.75,cex.lab=2)
lines(time,Taus[,1],col=1,lty=1,lwd=2)
lines(time,Taus[,2],col=2,lty=1,lwd=2)
legend('top',c('dT=0','dT=3'),lty=1,col=seq(1,2),lwd=2,cex=1.25,bty='n')

dev.new(bg='white')
par(mar=c(5,5,2,2))
plot(c(0,2*365),c(0,100),type="n",xlab='Time',ylab='Adult Density',cex.axis=1.75,cex.lab=2)
lines(time,Adults[,1],col=1,lty=1,lwd=2)
lines(time,Adults[,2],col=2,lty=1,lwd=2)
legend('top',c('dT=0','dT=3'),lty=1,col=seq(1,2),lwd=2,cex=1.25,bty='n')




 

library(stagePop)

#solver.options=list(DDEsolver='deSolve',atol=1e-5,rtol=1e-7,method='lsoda',hbsize=1e4)
solver.options=list(DDEsolver='PBS',tol=1e-7,hbsize=1e4,dt=0.01)

#parameters
Rin=10; V=1; K=1
num.strains=6
Yield=0.5#g of bacteria produced for 1 g of food
if (num.strains>1){Gmax=2+seq(1,num.strains)}else{Gmax=2}

case=2
if (case==1){
  num.stages=1;  stage.names='reproductive';  start=0.1;numDays=30}
if (case==2){
  num.stages=2;  stage.names=c('lagged','reproductive');  start=c(0,0.1);numDays=100}
  

strainsFunctions <- list(
                           reproFunc=function(x,time,species,strain){
                             if (species==1){reprod=Rin*V}
                             if (species==2){
                               reprod=x$Bacteria['reproductive',strain]*
                                 Gmax[strain]*x$Resource['food',1]/(x$Resource['food',1]+K)}
                             return(reprod)
                           },
                           deathFunc=function(stage,x,time,species,strain){
                           #per capita death rate (/d)
                             if (species==1){
                               uptake=0*seq(1,num.strains)
                               for (s in seq(1,num.strains)){
                                 uptake[s]=(Gmax[s]/(x$Resource['food',1]+K))*(x$Bacteria['reproductive',s]/Yield)
                               }
                               death=sum(uptake)+V
                             }
                             if (species==2){
                               if (stage==1){if(num.stages==2){death=0}else{death=V}}
                               if (stage==2){death=V}
                             }
                             return(death)
                           },
                           durationFunc=function(stage,x,time,species,strain){
                           #duration of each stage in days
                             durations=2*seq(1,num.strains)
                             return(durations[strain])
                           },
                           immigrationFunc=function(stage,x,time,species,strain){return(0)},
                           emigrationFunc=function(stage,x,time,species,strain){return(0)}
                           )


modelOutput = popModel(
  numSpecies=2,
  numStrains=c(1,num.strains),
  numStages=c(1,num.stages),
  ICs=list(matrix(Rin,nrow=1,ncol=1),matrix(start,nrow=num.stages,ncol=num.strains)),
  timeVec=seq(0,numDays,0.5),
  timeDependLoss=c(TRUE,FALSE),
  timeDependDuration=c(FALSE,FALSE),
  rateFunctions=strainsFunctions,
  solverOptions=solver.options,
  stageNames=list(c('food'),stage.names),
  speciesNames=c('Resource','Bacteria'),
  sumOverStrains=FALSE,
  plotStrainsFig=TRUE
  )

#Reproducing the second example in 'The systematic formulation of tractable single-species population models incorporating age structure'
#by WSC Gurney, RM Nisbet and J Lawton, Journal of Animal Ecology, 52, p479-495. 1983

library(stagePop)


#All the vectors are specified in the order of the life cycle
#e.g. start with eggs and finish with reproducing adults

#solver.options=list(DDEsolver='deSolve',atol=1e-4,rtol=1e-4,method='lsoda',hbsize=1e6)
solver.options=list(DDEsolver='PBS',tol=1e-6,hbsize=1e3,dt=0.1)

case=2#choose case (1 or 2)
if (case==1){
  num.stages=2
  stage.names=c('larvae','adults')
}else{
  num.stages=3
  stage.names=c('larvae','adults','dead adults')}

#--------------------------DEFINE RATE FUNCTIONS---------------------------------------
larvalCompFunctions <- list(
                            reproFunc=function(x,time,species,strain){
                              reprod=9.4*x$flies['adults',1]
                              return(reprod)
                            },
#-----------------------------------------------------------
                            deathFunc=function(stage,x,time,species,strain){
                              if (stage==1){v=5e-5*x$flies['larvae',1]}
                              if (stage>=2){if (case==1){v=0.2}else{v=0}}
                              return(v)
                            },
#-----------------------------------------------------------
                            durationFunc=function(stage,x,time,species,strain){
                              a=c(28,5)
                              return(a[stage])
                            },
#-----------------------------------------------------------
                            immigrationFunc=function(stage,x,time,species,strain){
                              v=0
                              if (time>=0 & time<=1){
                                if (stage==2){v=20}}
                              return(v)
                            },
                            emigrationFunc=function(stage,x,time,species,strain){return(0)}
                            )

#-------------------------------RUN MODEL---------------------------------------

modelOutput=popModel(
  numSpecies=1,
  numStages=num.stages,
  ICs=list(matrix(0,nrow=num.stages,ncol=1)),
  timeVec=seq(0,500,0.5),
  timeDependLoss=TRUE,
  solverOptions=solver.options,
  rateFunctions=larvalCompFunctions,
  stageNames=list(stage.names),
  speciesNames='flies'
  )

#This classic predator prey model but with stage structure for the predator
#only adult predators eat prey

library(stagePop)

growthRatePred=10
growthRatePrey=1
deathRatePrey=1
deathRatePred=c(1.0,0.5)
preyCarryCapacity=1
  
#solver.options=list(DDEsolver='deSolve',atol=1e-6,rtol=1e-6,method='lsoda',hbsize=1e4)
solver.options=list(DDEsolver='PBS',tol=1e-7,hbsize=1e4,dt=0.01)

case=1; print(paste('case',case))
if (case==1){juvPredDuration=0.1;lenTime=100}
if (case==2){juvPredDuration=0.1;lenTime=300}
if (case==3){juvPredDuration=1.8;lenTime=300}
if (case==4){juvPredDuration=0.1;lenTime=400;deathRatePred[1]=0}
if (case==5){juvPredDuration=5;lenTime=400;deathRatePred[1]=0}
if (case==6){juvPredDuration=15;lenTime=400;deathRatePred[1]=0}
if (case==7){juvPredDuration=20;lenTime=400;deathRatePred[1]=0}

ppFunctions <- list(
                    reproFunc=function(x,time,species,strain){
                      if (species==1){reprod=growthRatePrey*x$Prey['adult',1]}
                      if (species==2){reprod=growthRatePred*x$Prey['adult',1]*x$Predator['adult',1]}
                      return(max(0,reprod))
                    },
                    deathFunc=function(stage,x,time,species,strain){
                      if (species==1){
                        if (case==1){v=deathRatePrey*x$Predator['adult',1]}
                        if (case>1){v=deathRatePrey*x$Predator['adult',1]+growthRatePrey*x$Prey['adult',1]/preyCarryCapacity}}
                      if (species==2){v=deathRatePred[stage]}
                      return(max(0,v))
                    },
                    durationFunc=function(stage,x,time,species,strain){
                      return(juvPredDuration)
                    },
                    immigrationFunc=function(stage,x,time,species,strain){
                      return(0)
                    },
                    emigrationFunc=function(stage,x,time,species,strain){
                      return(0)
                    }
                    )
#-------------------------------RUN MODEL----------------------------------------------------
modelOutput=popModel(
  numSpecies=2,
  numStages=c(1,2),
  timeDependLoss=c(TRUE,FALSE),
  timeDependDuration=c(FALSE,FALSE),
  ICs=list(matrix(0.3),matrix(c(0,1),nrow=2,ncol=1)),
  timeVec=seq(0,lenTime,0.1),
  solverOptions=solver.options,
  plotFigs=TRUE,
  rateFunctions=ppFunctions,
  stageNames=list('adult',c('juvenile','adult')),
  speciesNames=c('Prey','Predator')
  )

#Variable stage duration (Nisbet and Gurney)
#used scaled version as in N&G appendix 2

#Food (F) is eaten by larvae (L)
#when larvae reach a certain mass they become adults (A).
#variables are scaled
#first 'species' is food

library(stagePop)

#All the vectors are specified in the order of the life cycle
#e.g. start with eggs and finish with reproducing adults

#PARAMETERS
fs=1     #rate of food supply
fmax=3   #max rate of food supply
F0=0.1   #initial food density
m=1      #number of mass units a larva must increase by before becoming an adult
epsilon=1#constant of proportionality between development and food consumption
K=1      #half sat constant for food consumption
q=5#500      #reproduction rate
dA=2#10     #adult death rate
dL=log(q/dA)  #larval death rate

solver.options=list(DDEsolver='deSolve',atol=1e-9,rtol=1e-9,method='lsoda',hbsize=1e4)
#solver.options=list(DDEsolver='PBS',tol=1e-9,hbsize=1e4,dt=0.01)

#--------------------------DEFINE RATE FUNCTIONS---------------------------------------
varDurFoodFunctions <- list(
                            reproFunc=function(x,time,species,strain){
                              if (species==1){reprod=fs}
                              if (species==2){reprod=q*x$Damselfly['adults',1]}
                              return(max(0,reprod))
                            },
                            deathFunc=function(stage,x,time,species,strain){
                              if(species==1){v=fmax*x$Damselfly['larvae',1]/(K+x$Food[1,1])}
                              if(species==2){a=c(dL,dA);v=a[stage]}
                              return(max(0,v))
                            },
                            durationFunc=function(stage,x,time,species,strain){
                              if (time==0 & species==2 & stage==1){v=m/(epsilon*fmax*F0/(K+F0))}
                              return(v)
                            },
                            develFunc=function(stage,x,time,species,strain){
                              if (species==2 & stage==1){v=epsilon*fmax*x$Food[1,1]/(K+x$Food[1,1])}
                              return(v)
                            },
                            immigrationFunc=function(stage,x,time,species,strain){
                              v=0
                              if (species==2 & stage==1){if (time>=0 & time <=0.1){v=1}}
                              return(v)
                            },
                            emigrationFunc=function(stage,x,time,species,strain){return(0)}
                            )


#-------------------------------RUN MODEL---------------------------------------
  
modelOutput=popModel(
  numSpecies=2,
  speciesNames=c('Food','Damselfly'),
  numStages=c(1,2),
  stageNames=list('one',c('larvae','adults')),
  numStrains=c(1,1),
  timeDependLoss=c(TRUE,FALSE),
  timeDependDuration=c(FALSE,TRUE),
  ICs=list(matrix(F0,1,1),matrix(0,nrow=2,ncol=1)),
  timeVec=seq(0,30,0.1),
  solverOptions=solver.options,
  rateFunctions=varDurFoodFunctions,
  sumOverStrains=TRUE
)

tauStar=(1/dL)*log(q/dA)
qdash=q*tauStar
dAdash=dA*tauStar
fmaxdash=epsilon*fmax*tauStar/m
Kdash=K/(fs*tauStar)
print(c(qdash,dAdash,fmaxdash,Kdash))

tauStar=log(q/dA)/dL
Lstar=fs*tauStar*epsilon/m
Fstar=K/((epsilon*fmax*tauStar/m)-1)
Astar=dL*Lstar/(q-dA)

print(c('tauStar','Fstar','Lstar','Astar'))
print(c(tauStar,Fstar,Lstar,Astar))
print(modelOutput[length(modelOutput[,1]),c('dur.Damselfly.larvae','Food.one','Damselfly.larvae','Damselfly.adults')])

#plot larval stage duration
dev.new()
par(mar=c(5,5,1,1))
plot(modelOutput[,'time'],modelOutput[,'dur.Damselfly.larvae'],type='l',xlab='time',ylab='Larval stage duration',cex.axis=1.5,cex.lab=2.5,lwd=2)

#plot rate of uptake of food 
foodUptake=epsilon*fmax*modelOutput[,'Food.one']/(K+modelOutput[,'Food.one'])
dev.new()
par(mar=c(5,5,1,1))
plot(modelOutput[,'time'],foodUptake,type='l',xlab='time',ylab='Food uptake rate',cex.axis=1.5,cex.lab=2.5,lwd=2)

#This classic predator prey model (with no stage structure)

library(stagePop)

growthRatePred=10
growthRatePrey=1
deathRatePrey=1
deathRatePred=0.5


#solver.options=list(DDEsolver='deSolve',atol=1e-6,rtol=1e-6,method='lsoda',hbsize=1e4)
solver.options=list(DDEsolver='PBS',tol=1e-7,hbsize=1e4,dt=0.01)

ppFunctions <- list(
                    reproFunc=function(x,time,species,strain){
                      if (species==1){reprod=growthRatePrey*x$prey['adults',1]}
                      if(species==2){reprod=growthRatePred*x$prey['adults',1]*x$predator['adults',1]}
                      return(max(0,reprod))
                    },
                    deathFunc=function(stage,x,time,species,strain){
                      if (species==1){v=deathRatePrey*x$predator['adults',1]}
                      if (species==2){v=deathRatePred}
                      return(max(0,v))
                    },
                    durationFunc=function(stage,x,time,species,strain){
                      return(0)
                    },
                    immigrationFunc=function(stage,x,time,species,strain){
                      return(0)
                    },
                    emigrationFunc=function(stage,x,time,species,strain){
                      return(0)
                    }
                    )
#-------------------------------RUN MODEL----------------------------------------------------
modelOutput=popModel(
  numSpecies=2,
  numStages=c(1,1),
  timeDependLoss=c(TRUE,FALSE),
  timeDependDuration=c(FALSE,FALSE),
  ICs=list(matrix(0.3,1,1),matrix(1,1,1)),
  timeVec=seq(0,100,0.1),
  solverOptions=solver.options,
  plotFigs=TRUE,
  rateFunctions=ppFunctions,
  speciesNames=c('prey','predator'),
  stageNames=list('adults','adults')
)

dev.new()
par(mar=c(5,5,2,2))
plot(modelOutput[,2],modelOutput[,3],type='l',xlab='prey',ylab='predator',cex.lab=2,cex.axis=1.5)

x=0.3; y=1
C=growthRatePrey*log(y)-deathRatePrey*y-growthRatePred*x+deathRatePred*log(x)

x=modelOutput[,2]; y=modelOutput[,3]
Cmod=growthRatePrey*log(y)-deathRatePrey*y-growthRatePred*x+deathRatePred*log(x)
print(c(C,summary(Cmod)))

#Nicholson's Blow Flies (Gurney et al 1983)
#Reproducing the first example in 'The systematic formulation of tractable single-species population models incorporating age structure'
#by WSC Gurney, RM Nisbet and J Lawton, Journal of Animal Ecology, 52, p479-495, 1983

#library(stagePop)

#All the vectors are specified in the order of the life cycle
#e.g. start with eggs and finish with reproducing adults

#solver.options=list(DDEsolver='deSolve',atol=1e-3,rtol=1e-3,hbsize=1e4)
solver.options=list(DDEsolver='PBS',tol=1e-4,hbsize=1e4,dt=0.01)

#--------------------------DEFINE RATE FUNCTIONS---------------------------------------
blowFliesFunctions <- list(
                           reproFunc=function(x,time,species,strain){
                             A0=600;  q=8.5
                             reprod=q*x$blowflies['adults',1]*exp(-x$blowflies['adults',1]/A0)
                             return(reprod)
                           },
                           deathFunc=function(stage,x,time,species,strain){
                           #per capita death rate (/d)
                             a=c(0.07,0.004,0.003,0.0025,0.27)
                             return(a[stage])
                           },
                           durationFunc=function(stage,x,time,species,strain){
                           #duration of each stage in days
                             a=c(0.6,5.0,5.9,4.1)
                             return(a[stage])
                           },
                           immigrationFunc=function(stage,x,time,species,strain){
                             v=0
                             if (stage==5){if (time>=0 & time<=1){v=100}}
                             return(v)
                           },
                           emigrationFunc=function(stage,x,time,species,strain){return(0)}
                           )

#-------------------------------RUN MODEL---------------------------------------

modelOutput = popModel(
  numSpecies=1,
  numStages=5,
  ICs=list(matrix(0,nrow=5,ncol=1)),
  timeVec=seq(0,200,0.5),
  timeDependLoss=TRUE,
  timeDependDuration=FALSE,
  rateFunctions=blowFliesFunctions,
  solverOptions=solver.options,
  stageNames=list(c('eggs','larvae','pupae','juveniles','adults')),
  speciesNames=c('blowflies'),
  saveFig=FALSE
)

#Host parasitoid model 
#Briggs CJ. 1993. Competition among parasitoid species on a stage-structured host and its effect on host suppression. The American Naturalist 141, 372-397.

library(stagePop)

#All the vectors are specified in the order of the life cycle
#e.g. start with eggs and finish with reproducing adults
attackRateP=1
attackRateQ=2
TE=0.5
TL=0.5
TJP=0.4
TJQ=0.4
deathE=0.1; deathL=0.1; deathA=0.1
deathJP=0.1; deathP=8.0
deathJQ=0.1; deathQ=8.0
rho=33 #total lifetime fecundity 

#Analytical Solution#---------------------------------------------
BriggAnalytic=function(Ppresent,attackRates,durations,deathRates,rho){

  attackRateP=attackRates[1];  attackRateQ=attackRates[2]
  TE=durations[1];  TL=durations[2]
  TJP=durations[3];  TJQ=durations[4]
  deathE=deathRates[1]; deathL=deathRates[2]; deathA=deathRates[3]
  deathJP=deathRates[4]; deathP=deathRates[5]
  deathJQ=deathRates[6]; deathQ=deathRates[7]

  if (Ppresent){
    Pstar=(log(rho)-deathL*TL-deathE*TE)/(attackRateP*TE)
    Qstar=0
  }else{
    Qstar=(log(rho)-deathL*TL-deathE*TE)/(attackRateQ*TL)
    Pstar=0
  }
  
  yP=attackRateP*Pstar+deathE
  yQ=attackRateQ*Qstar+deathL
  
  if (Ppresent){
    Estar=deathP/(attackRateP*exp(-deathJP*TJP))
    Astar=Estar*yP/(rho*deathA*(1-exp(-yP*TE)))
    Lstar=(rho*deathA*Astar*(1-exp(-yQ*TL))*exp(-yP*TE))/yQ
  }else{
    Lstar=deathQ/(attackRateQ*exp(-deathJQ*TJQ))
    Astar=Lstar*yQ/(rho*deathA*(1-exp(-yQ*TL))*exp(-yP*TE))
    Estar=Astar*rho*deathA*(1-exp(-yP*TE))/yP
  }
  
  return(c(Estar,Lstar,Astar,Pstar,Qstar))
}

#-------------------------------------------------------------
durations=c(c(TE,TL),TJP,TJQ)
deathRates=c(deathE,deathL,deathA,deathJP,deathP,deathJQ,deathQ)
attackRates=c(attackRateP,attackRateQ)
analy=BriggAnalytic(FALSE,attackRates,durations,deathRates,rho)
LstarQ=analy[2]
AstarQ=analy[3]
Qstar=analy[5]

BriggsFunctions <- list(
              reproFunc=function(x,time,species,strain){
                if (species==1){reprod=rho*deathA*x$Host['adults',1]}
                if (species==2){reprod=attackRateP*x$'Egg Parasitoid'['adults',1]*x$Host['eggs',1]}
                if (species==3){reprod=attackRateQ*x$'Larval Parasitoid'['adults',1]*x$Host['larvae',1]}
                return(max(0,reprod))
              },
              deathFunc=function(stage,x,time,species,strain){
                if (species==1){a=c(deathE,deathL,deathA);v=a[stage]
                    if (stage==1){v=a[stage]+attackRateP*max(x$'Egg Parasitoid'['adults',1],0)}
                    if (stage==2){v=a[stage]+attackRateQ*max(x$'Larval Parasitoid'['adults',1],0)}}
                if (species==2){a=c(deathJP,deathP);v=a[stage]}
                if (species==3){a=c(deathJQ,deathQ);v=a[stage]}
                return(max(0,v))
                },
               durationFunc=function(stage,x,time,species,strain){
                 if (species==1){a=c(TE,TL)}
                 if (species==2){a=TJP}
                 if (species==3){a=TJQ}
                 return(a[stage])
               },
               immigrationFunc=function(stage,x,time,species,strain){
                 v=0
                 if (species==1){if (time>=0 & time<=0.1){f1=rho*deathA*AstarQ
                   if (stage==1){v=f1}
                   if (stage==2){v=f1*exp(-deathE*TE)}
                   if (stage==3){v=f1*exp(-deathE*TE-deathL*TL)}}}
                 if(species==2){if(time>=20 & time<=20.1){if(stage==2){v=1}}}
                 if(species==3){if(time>=0 & time<=0.1){if(stage==1){v=attackRateQ*Qstar*LstarQ}}}
                 return(v)
               },
               emigrationFunc=function(stage,x,time,species,strain){return(0)}
               )

modelOutput=popModel(
  numSpecies=3,
  numStages=c(3,2,2),
  timeVec=seq(0,50,0.1),
  rateFunctions=BriggsFunctions,
  timeDependLoss=c(TRUE,FALSE,FALSE),
  timeDependDuration=c(FALSE,FALSE,FALSE),
  ICs=list(matrix(0,nrow=3,ncol=1),matrix(0,nrow=2,ncol=1),matrix(0,nrow=2,ncol=1)),
  solverOptions=list(DDEsolver='PBS',tol=1e-7,hbsize=1e4,dt=0.01),
  speciesNames=c('Host','Egg Parasitoid','Larval Parasitoid'),
  stageNames=list(c('eggs','larvae','adults'),c('eggs','adults'),c('eggs','adults')),
  saveFig=FALSE
  )


#check results against equilibrium values (Pg 392 in Briggs 1993)
time=modelOutput[,1]
print('model')
L=length(modelOutput[,1])
print(round(modelOutput[L-1,c(2:4,6,8)],3))
if (modelOutput[L-1,8]>modelOutput[L-1,6]){
  print('Just Q')
  Ppresent=FALSE
}else{
  print('Just P')
  Ppresent=TRUE  }

print('Analytical')
print(round(BriggAnalytic(Ppresent,attackRates,durations,deathRates,rho),3))

#Example where the juvenile stage duration is dependent upon temperature.

library(stagePop)

#solver.options=list(DDEsolver='deSolve',atol=1e-6,rtol=1e-6,hbsize=1e5)
solver.options=list(DDEsolver='PBS',tol=1e-8,hbsize=1e4,dt=0.01)

maxDur=200
minDur=60
tempFunc=function(time){
  T=15*(1-cos(2*pi*(time+80)/365))
  return(T)}

tauFunc=function(T){
  v=min(minDur+((T-20)/2)^2,maxDur)
  return(v)}

varDurEnvFunctions<-list(
                         reproFunc=function(x,time,species,strain){
                           A0=600;  q=11.5
                           reprod=q*x$Nematodes['adults',1]*exp(-x$Nematodes['adults',1]/A0)
                           return(max(0,reprod))
                         },
                         deathFunc=function(stage,x,time,species,strain){
                           a=c(0.05,0.05)
                           v=a[stage]
                           return(max(0,v))
                         },
                         develFunc=function(stage,x,time,species,strain){
                           T=tempFunc(time)
                           v=1/tauFunc(T)
                           return(v)
                         },
                         durationFunc=function(stage,x,time,species,strain){
                           if (time==0){
                             T=tempFunc(time)
                             v=tauFunc(T)}
                           return(v)
                         },
                         immigrationFunc=function(stage,x,time,species,strain){
                           v=0
                           if (stage==2){if (time>=0 & time <=0.1){v=1}}
                           return(v)
                         },
                         emigrationFunc=function(stage,x,time,species,strain){return(0)}
)


modelOutput=popModel(
  numSpecies=1,
  numStages=2,
  timeDependLoss=FALSE,
  timeDependDuration=TRUE,
  ICs=list(matrix(0,nrow=2,ncol=1)),
  timeVec=seq(0,365*6,1),
  solverOptions=solver.options,
  rateFunctions=varDurEnvFunctions,
  stageNames=list(c('juveniles','adults')),
  speciesNames=c('Nematodes')
  )



dev.new()
par(mar=c(5,5,5,5))
T=seq(0,40,0.5); Tau=T*0
for (i in seq(1,length(T))){Tau[i]=tauFunc(T[i])}
plot(T,Tau,type='l',xlab='Temperature (oC)',ylab='Juvenile stage Duration (days)',cex.axis=1.75,cex.lab=2)

dev.new()
par(mar=c(5,5,5,5))
time=modelOutput[,'time']
temps=tempFunc(time)
plot(c(0,2*365),c(0,max(temps)),type="n",xlab='Time',ylab='Temperature',cex.axis=1.75,cex.lab=2)
lines(time,temps,col=1,lty=1,lwd=2)


dev.new()
par(mar=c(5,5,5,5))
tau=modelOutput[,'dur.Nematodes.juveniles']
tempsTau=0*time
for (i in seq(1,length(time))){tempsTau[i]=tauFunc(tempFunc(time[i]))}
plot(c(0,2*365),c(minDur*0.9,0.9*maxDur),type="n",xlab='Time',ylab='Juvenile Stage Duration (d)',cex.axis=1.75,cex.lab=2)
lines(time,tau,col=1,lty=1,lwd=2)
lines(time,tempsTau,col=2,lty=1,lwd=2)
legend('topleft',c('from StagePop','if T(t)=Tc'),lty=1,col=seq(1,2),lwd=2,cex=1.75)
